#ifndef __DMW96_TDM_H_

/* TDM registers: */
#define TDM_ENABLE      0x0000
#define TDM_CONFIG_1    0x0004
#define TDM_CONFIG_1_AUTO_SYNC       (1 << 13)
#define TDM_CONFIG_1_CLK_MSTR_SLV    (1 << 12)
#define TDM_CONFIG_1_FSYNC_MSTR_SLV  (1 << 11)
#define TDM_CONFIG_1_SYNC_EDGE       (1 << 10)
#define TDM_CONFIG_1_RX_EDGE         (1 <<  9)
#define TDM_CONFIG_1_TX_EDGE         (1 <<  8)
#define TDM_CONFIG_1_TIME_SLOTS      0x1F
#define TDM_CONFIG_2    0x0008
#define TDM_CONFIG_2_SHIFT      (1 << 9)
#define TDM_CONFIG_2_TRUNCATE   (1 << 8)
#define TDM_CONFIG_2_BANK_SIZE  0x07
#define TDM_FSYNC       0x0010
#define TDM_FSYNC_DUR   0x0014
#define TDM_FIFO_WM     0x0018
#define TDM_INT_EN      0x0020
#define TDM_INT_EN_TX_FLAGS           	(1 << 5)
#define TDM_INT_EN_FSYNC           	(1 << 4)
#define TDM_INT_EN_RX_FULL			(1 << 3)
#define TDM_INT_EN_RX_WM			(1 << 2)
#define TDM_INT_EN_TX_EMPTY		(1 << 1)
#define TDM_INT_EN_TX_WM			(1 << 0)
#define TDM_INT_CLR     0x0028
#define TDM_INT_CLR_TX_FLAGS         (1 << 3)
#define TDM_INT_CLR_FSYNC            (1 << 2)
#define TDM_INT_CLR_RX_OVRN          (1 << 1)
#define TDM_INT_CLR_TX_UNDRN         (1 << 0)
#define TDM_INT_STATUS  0x002C
#define TDM_INT_STATUS_TX_FLAGS		(1<<5)
#define TDM_INT_STATUS_FSYNC			(1<<4)
#define TDM_INT_STATUS_RX_OVRN		(1<<3)
#define TDM_INT_STATUS_RX				(1<<2)
#define TDM_INT_STATUS_TX_UNDRN		(1<<1)
#define TDM_INT_STATUS_TX				(1<<0)
#define TDM_STATUS      0x0030
#define TDM_TX_FIFO     0x0038
#define TDM_RX_FIFO     0x003C
/* Frame descriptor array */
#define FDA_REG_ADDR_START	(0x1800)
#define FDA_REG_ADDR(n)		(FDA_REG_ADDR_START + 4*(n))

typedef struct
{
	unsigned int reg_base;
	unsigned int reg_size;
	const char *clk;
	unsigned int irqno;
	unsigned int dma_rx;
	unsigned int dma_tx;
	unsigned int reset;
}tdm_resource_t;

#endif
